gtkmm: Gtk::ComboBox Class Reference

gtkmm 4.23.2

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::ComboBox Class Reference
Widgets

A widget used to choose from a list of items. More...

`#include <gtkmm/combobox.h>`

Inheritance diagram for Gtk::ComboBox:
[legend]

## Public Types
typedef TreeView::SlotRowSeparator | SlotRowSeparator
Public Types inherited from Gtk::Widget
using | PreferredSize = MinimumNatural<Requisition>
| Structure returned by the non-output-parameter overload of get_preferred_size().
using | SlotTick = sigc::slot<bool(const Glib::RefPtr<Gdk::FrameClock>&)>
| Callback type for adding a function to update animations.
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gtk::Accessible
enum class | Role { Role::ALERT , Role::ALERT_DIALOG , Role::BANNER , Role::BUTTON , Role::CAPTION , Role::CELL , Role::CHECKBOX , Role::COLUMN_HEADER , Role::COMBO_BOX , Role::COMMAND , Role::COMPOSITE , Role::DIALOG , Role::DOCUMENT , Role::FEED , Role::FORM , Role::GENERIC , Role::GRID , Role::GRID_CELL , Role::GROUP , Role::HEADING , Role::IMG , Role::INPUT , Role::LABEL , Role::LANDMARK , Role::LEGEND , Role::LINK , Role::LIST , Role::LIST_BOX , Role::LIST_ITEM , Role::LOG , Role::MAIN , Role::MARQUEE , Role::MATH , Role::METER , Role::MENU , Role::MENU_BAR , Role::MENU_ITEM , Role::MENU_ITEM_CHECKBOX , Role::MENU_ITEM_RADIO , Role::NAVIGATION , Role::NONE , Role::NOTE , Role::OPTION , Role::PRESENTATION , Role::PROGRESS_BAR , Role::RADIO , Role::RADIO_GROUP , Role::RANGE , Role::REGION , Role::ROW , Role::ROW_GROUP , Role::ROW_HEADER , Role::SCROLLBAR , Role::SEARCH , Role::SEARCH_BOX , Role::SECTION , Role::SECTION_HEAD , Role::SELECT , Role::SEPARATOR , Role::SLIDER , Role::SPIN_BUTTON , Role::STATUS , Role::STRUCTURE , Role::SWITCH , Role::TAB , Role::TABLE , Role::TAB_LIST , Role::TAB_PANEL , Role::TEXT_BOX , Role::TIME , Role::TIMER , Role::TOOLBAR , Role::TOOLTIP , Role::TREE , Role::TREE_GRID , Role::TREE_ITEM , Role::WIDGET , Role::WINDOW , Role::TOGGLE_BUTTON , Role::APPLICATION , Role::PARAGRAPH , Role::BLOCK_QUOTE , Role::ARTICLE , Role::COMMENT , Role::TERMINAL }
| The accessible role for a Gtk::Accessible implementation. More...
enum class | State { State::BUSY , State::CHECKED , State::DISABLED , State::EXPANDED , State::HIDDEN , State::INVALID , State::PRESSED , State::SELECTED , State::VISITED }
| The possible accessible states of a Gtk::Accessible. More...
enum class | Property { Property::AUTOCOMPLETE , Property::DESCRIPTION , Property::HAS_POPUP , Property::KEY_SHORTCUTS , Property::LABEL , Property::LEVEL , Property::MODAL , Property::MULTI_LINE , Property::MULTI_SELECTABLE , Property::ORIENTATION , Property::PLACEHOLDER , Property::READ_ONLY , Property::REQUIRED , Property::ROLE_DESCRIPTION , Property::SORT , Property::VALUE_MAX , Property::VALUE_MIN , Property::VALUE_NOW , Property::VALUE_TEXT , Property::HELP_TEXT }
| The possible accessible properties of a Gtk::Accessible. More...
enum class | Relation { Relation::ACTIVE_DESCENDANT , Relation::COL_COUNT , Relation::COL_INDEX , Relation::COL_INDEX_TEXT , Relation::COL_SPAN , Relation::CONTROLS , Relation::DESCRIBED_BY , Relation::DETAILS , Relation::ERROR_MESSAGE , Relation::FLOW_TO , Relation::LABELLED_BY , Relation::OWNS , Relation::POS_IN_SET , Relation::ROW_COUNT , Relation::ROW_INDEX , Relation::ROW_INDEX_TEXT , Relation::ROW_SPAN , Relation::SET_SIZE , Relation::LABEL_FOR , Relation::DESCRIPTION_FOR , Relation::CONTROLLED_BY , Relation::DETAILS_FOR , Relation::ERROR_MESSAGE_FOR , Relation::FLOW_FROM }
| The possible accessible relations of a Gtk::Accessible. More...
enum class | PlatformState { PlatformState::FOCUSABLE , PlatformState::FOCUSED , PlatformState::ACTIVE }
| The various platform states which can be queried using Gtk::Accessible::get_platform_state(). More...
enum class | AnnouncementPriority { AnnouncementPriority::LOW , AnnouncementPriority::MEDIUM , AnnouncementPriority::HIGH }
| The priority of an accessibility announcement. More...
Public Types inherited from Gtk::CellLayout
typedef sigc::slot< void(const TreeModel::const_iterator &)> | SlotCellData

## Public Member Functions
| ComboBox (ComboBox && src) noexcept
ComboBox & | operator= (ComboBox && src) noexcept
| ComboBox (const ComboBox &)=delete
ComboBox & | operator= (const ComboBox &)=delete
| ~ComboBox () noexcept override
GtkComboBox * | gobj ()
| Provides access to the underlying C GObject.
const GtkComboBox * | gobj () const
| Provides access to the underlying C GObject.
| ComboBox (bool has_entry=false)
| Creates a new empty ComboBox, optionally with an entry.
| ComboBox (const Glib::RefPtr< TreeModel > & model, bool has_entry=false)
| Creates a new ComboBox with the model initialized to model, optionally with an entry.
int | get_active_row_number () const
| Returns the index of the currently active item.
TreeModel::iterator | get_active ()
| Gets an iterator that points to the current active item, if it exists.
TreeModel::const_iterator | get_active () const
| Gets an iterator that points to the current active item, if it exists.
void | set_active (int index)
| Sets the active item of combo_box to be the item at index.
void | set_active (const TreeModel::const_iterator & iter)
| Sets the current active item to be the one referenced by iter.
Glib::ustring | get_entry_text () const
| Get the text in the entry, if there is an entry.
void | unset_active ()
| Causes no item to be active.
Glib::RefPtr< TreeModel > | get_model ()
| Returns the Gtk::TreeModel of combo_box.
Glib::RefPtr< const TreeModel > | get_model () const
| Returns the Gtk::TreeModel of combo_box.
void | set_model (const Glib::RefPtr< TreeModel > & model)
| Sets the model used by combo_box to be model.
void | unset_model ()
| Remove the model from the ComboBox.
void | set_row_separator_func (const SlotRowSeparator & slot)
| Sets the row separator function, which is used to determine whether a row should be drawn as a separator.
void | unset_row_separator_func ()
| Causes no separators to be drawn.
void | set_button_sensitivity (SensitivityType sensitivity)
| Sets whether the dropdown button of the combo box should update its sensitivity depending on the model contents.
SensitivityType | get_button_sensitivity () const
| Returns whether the combo box sets the dropdown button sensitive or not when there are no items in the model.
bool | get_has_entry () const
| Returns whether the combo box has an entry.
void | set_entry_text_column (const TreeModelColumnBase & text_column) const
| Sets the model column which combo_box should use to get strings from to be text_column.
void | set_entry_text_column (int text_column)
| Sets the model column which combo_box should use to get strings from to be text_column.
int | get_entry_text_column () const
| Returns the column which combo_box is using to get the strings from to display in the internal entry.
void | set_popup_fixed_width (bool fixed=true)
| Specifies whether the popup’s width should be a fixed width.
bool | get_popup_fixed_width () const
| Gets whether the popup uses a fixed width.
void | popup ()
| Pops up the menu or dropdown list of combo_box.
void | popup (const Glib::RefPtr< Gdk::Device > & device)
| Pops up the menu of combo_box.
void | popdown ()
| Hides the menu or dropdown list of combo_box.
int | get_id_column () const
| Returns the column which combo_box is using to get string IDs for values from.
void | set_id_column (int id_column)
| Sets the model column which combo_box should use to get string IDs for values from.
Glib::ustring | get_active_id () const
| Returns the ID of the active row of combo_box.
bool | set_active_id (const Glib::ustring & active_id)
| Changes the active row of the combo box to the one that has an ID equal to active_id.
void | set_child (Widget & child)
| Sets the child widget of combo_box.
void | unset_child ()
Widget * | get_child ()
| Gets the child widget of combo_box.
const Widget * | get_child () const
| Gets the child widget of combo_box.
Entry * | get_entry ()
const Entry * | get_entry () const
Glib::PropertyProxy< Glib::RefPtr< TreeModel > > | property_model ()
| The model from which the combo box takes its values.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TreeModel > > | property_model () const
| The model from which the combo box takes its values.
Glib::PropertyProxy< int > | property_active ()
| The item which is currently active.
Glib::PropertyProxy_ReadOnly< int > | property_active () const
| The item which is currently active.
Glib::PropertyProxy< bool > | property_has_frame ()
| The has-frame property controls whether a frame is drawn around the entry.
Glib::PropertyProxy_ReadOnly< bool > | property_has_frame () const
| The has-frame property controls whether a frame is drawn around the entry.
Glib::PropertyProxy_ReadOnly< bool > | property_popup_shown () const
| Whether the combo boxes dropdown is popped up.
Glib::PropertyProxy< SensitivityType > | property_button_sensitivity ()
| Whether the dropdown button is sensitive when the model is empty.
Glib::PropertyProxy_ReadOnly< SensitivityType > | property_button_sensitivity () const
| Whether the dropdown button is sensitive when the model is empty.
Glib::PropertyProxy< bool > | property_popup_fixed_width ()
| Whether the popup's width should be a fixed width matching the allocated width of the combo box.
Glib::PropertyProxy_ReadOnly< bool > | property_popup_fixed_width () const
| Whether the popup's width should be a fixed width matching the allocated width of the combo box.
Glib::PropertyProxy_ReadOnly< bool > | property_has_entry () const
| Whether the combo box has an entry.
Glib::PropertyProxy< int > | property_entry_text_column ()
| The model column to associate with strings from the entry.
Glib::PropertyProxy_ReadOnly< int > | property_entry_text_column () const
| The model column to associate with strings from the entry.
Glib::PropertyProxy< int > | property_id_column ()
| The model column that provides string IDs for the values in the model, if != -1.
Glib::PropertyProxy_ReadOnly< int > | property_id_column () const
| The model column that provides string IDs for the values in the model, if != -1.
Glib::PropertyProxy< Glib::ustring > | property_active_id ()
| The value of the ID column of the active row.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_active_id () const
| The value of the ID column of the active row.
Glib::PropertyProxy< Widget * > | property_child ()
| The child widget.
Glib::PropertyProxy_ReadOnly< Widget * > | property_child () const
| The child widget.
Glib::SignalProxy< void()> | signal_changed ()
Glib::SignalProxy< Glib::ustring(const TreeModel::Path &)> | signal_format_entry_text ()
Public Member Functions inherited from Gtk::Widget
| Widget (Widget && src) noexcept
Widget & | operator= (Widget && src) noexcept
| Widget (const Widget &)=delete
Widget & | operator= (const Widget &)=delete
| ~Widget () noexcept override
| Destroys the widget.
GtkWidget * | gobj ()
| Provides access to the underlying C GObject.
const GtkWidget * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ConstraintTarget > | make_refptr_constrainttarget ()
| Converts this widget to a reference counted Gtk::ConstraintTarget.
Glib::RefPtr< const ConstraintTarget > | make_refptr_constrainttarget () const
| Converts this widget to a reference counted Gtk::ConstraintTarget.
void | show ()
| Flags a widget to be displayed.
void | hide ()
| Reverses the effects of [method.Gtk.Widget.show].
void | queue_draw ()
| Schedules this widget to be redrawn.
void | queue_resize ()
| Flags a widget to have its size renegotiated.
void | queue_allocate ()
| Flags the widget for a rerun of the size_allocate_vfunc() function.
void | size_allocate (const Allocation & allocation, int baseline)
| Allocates widget with a transformation that translates the origin to the position in allocation.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | measure (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
| Measures widget in the orientation orientation and for the given for_size.
Measurements | measure (Orientation orientation, int for_size=-1) const
| Like the other overload of measure() but returns a structure holding the sizes/baselines instead of using output parameters.
void | get_preferred_size (Requisition & minimum_size, Requisition & natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management.
PreferredSize | get_preferred_size () const
| Like the other overload of get_preferred_size() but returns a structure holding the sizes instead of using output parameters.
void | set_layout_manager (const Glib::RefPtr< LayoutManager > & layout_manager)
| Sets the layout manager to use for measuring and allocating children of the widget.
void | unset_layout_manager ()
| Undoes the effect of a previous call to set_layout_manager().
Glib::RefPtr< LayoutManager > | get_layout_manager ()
| Retrieves the layout manager of the widget.
Glib::RefPtr< const LayoutManager > | get_layout_manager () const
| Retrieves the layout manager of the widget.
bool | mnemonic_activate (bool group_cycling)
| Emits the signal_mnemonic_activate() signal.
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them.
void | set_can_focus (bool can_focus=true)
| Sets whether the input focus can enter the widget or any of its children.
bool | get_can_focus () const
| Determines whether the input focus can enter the widget or any of its children.
void | set_focusable (bool focusable=true)
| Sets whether the widget can own the input focus.
bool | get_focusable () const
| Determines whether the widget can own the input focus.
bool | has_focus () const
| Determines if the widget has the global input focus.
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus.
bool | grab_focus ()
| Causes widget to have the keyboard focus for the window that it belongs to.
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse.
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse.
void | set_can_target (bool can_target=true)
| Sets whether the widget can be the target of pointer events.
bool | get_can_target () const
| Queries whether the widget can be the target of pointer events.
bool | has_default () const
| Determines whether the widget is the current default widget within its toplevel.
void | set_receives_default (bool receives_default=true)
| Sets whether the widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | get_receives_default () const
| Determines whether the widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
void | set_name (const Glib::ustring & name)
| Sets a widgets name.
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget.
void | set_state_flags (StateFlags flags, bool clear=true)
| Turns on flag values in the current widget state.
void | unset_state_flags (StateFlags flags)
| Turns off flag values for the current widget state.
StateFlags | get_state_flags () const
| Returns the widget state as a flag set.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of the widget.
bool | get_sensitive () const
| Returns the widget’s sensitivity.
bool | is_sensitive () const
| Returns the widget’s effective sensitivity.
void | set_visible (bool visible=true)
| Sets the visibility state of widget.
bool | get_visible () const
| Determines whether the widget is visible.
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible.
bool | is_drawable () const
| Determines whether the widget can be drawn to.
bool | get_realized () const
| Determines whether the widget is realized.
bool | get_mapped () const
| Returns whether the widget is mapped.
void | set_child_visible (bool visible=true)
| Sets whether the widget should be mapped along with its parent.
bool | get_child_visible () const
| Gets the value set with set_child_visible().
int | get_allocated_width () const
| Returns the width that has currently been allocated to the widget.
int | get_allocated_height () const
| Returns the height that has currently been allocated to the widget.
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to the widget.
Allocation | get_allocation () const
| Retrieves the widget’s location.
std::optional< Gdk::Graphene::Rect > | compute_bounds (const Widget & target) const
| Computes the bounds for the widget in the coordinate space of target.
std::optional< Gdk::Graphene::Point > | compute_point (const Widget & target, const Gdk::Graphene::Point & point) const
| Translates the given point in the widget's coordinates to coordinates relative to target’s coordinate system.
int | get_width () const
| Returns the content width of the widget.
int | get_height () const
| Returns the content height of the widget.
int | get_baseline () const
| Returns the baseline that has currently been allocated to the widget.
int | get_size (Orientation orientation) const
| Returns the content width or height of the widget.
Widget * | get_parent ()
| Returns the parent widget of the widget.
const Widget * | get_parent () const
| Returns the parent widget of the widget.
Root * | get_root ()
| Returns the Gtk::Root widget of the widget.
const Root * | get_root () const
| Returns the Gtk::Root widget of the widget.
Native * | get_native ()
| Returns the nearest Gtk::Native ancestor of the widget.
const Native * | get_native () const
| Returns the nearest Gtk::Native ancestor of the widget.
bool | child_focus (DirectionType direction)
| Called by widgets as the user moves around the window using keyboard shortcuts.
bool | keynav_failed (DirectionType direction)
| Emits the signal_keynav_failed() signal on the widget.
void | error_bell ()
| Notifies the user about an input-related error on the widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of the widget.
void | get_size_request (int & width, int & height) const
| Gets the size request that was explicitly set for the widget.
Requisition | get_size_request () const
| Like the other overload of get_size_request() but returns a structure holding the sizes instead of using output parameters.
void | set_opacity (double opacity)
| Requests the widget to be rendered partially transparent.
double | get_opacity () const
| Fetches the requested opacity for the widget.
void | set_overflow (Overflow overflow)
| Sets how the widget treats content that is drawn outside the it's content area.
Overflow | get_overflow () const
| Returns the widget’s overflow value.
Widget * | get_ancestor (GType widget_type)
| Gets the first ancestor of the widget with type widget_type.
const Widget * | get_ancestor (GType widget_type) const
| Gets the first ancestor of the widget with type widget_type.
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels.
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the display for the window that the widget belongs to.
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the display for the window that the widget belongs to.
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for the widget.
Glib::RefPtr< Gdk::Clipboard > | get_clipboard ()
| Gets the clipboard object for the widget.
Glib::RefPtr< const Gdk::Clipboard > | get_clipboard () const
| Gets the clipboard object for the widget.
Glib::RefPtr< Gdk::Clipboard > | get_primary_clipboard ()
| Gets the primary clipboard of the widget.
Glib::RefPtr< const Gdk::Clipboard > | get_primary_clipboard () const
| Gets the primary clipboard of the widget.
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space.
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space.
bool | get_hexpand_set () const
| Gets whether the hexpand flag has been explicitly set.
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag will be used.
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space.
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space.
bool | get_vexpand_set () const
| Gets whether the vexpand flag has been explicitly set.
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag will be used.
bool | compute_expand (Orientation orientation)
| Computes whether a parent widget should give this widget extra space when possible.
void | set_expand (bool expand=true)
| Sets whether the widget would like any available extra space in both directions.
Align | get_halign () const
| Gets the horizontal alignment of the widget.
void | set_halign (Align align)
| Sets the horizontal alignment of the widget.
Align | get_valign () const
| Gets the vertical alignment of the widget.
void | set_valign (Align align)
| Sets the vertical alignment of the widget.
int | get_margin_start () const
| Gets the start margin of the widget.
void | set_margin_start (int margin)
| Sets the start margin of the widget.
int | get_margin_end () const
| Gets the end margin of the widget.
void | set_margin_end (int margin)
| Sets the end margin of the widget.
int | get_margin_top () const
| Gets the top margin of the widget.
void | set_margin_top (int margin)
| Sets the top margin of the widget.
int | get_margin_bottom () const
| Gets the bottom margin of the widget.
void | set_margin_bottom (int margin)
| Sets the bottom margin of the widget.
void | set_margin (int margin)
| Set all 4 margins to the same value.
bool | is_ancestor (Widget & ancestor) const
| Determines whether the widget is a descendent of ancestor.
bool | translate_coordinates (Widget & dest_widget, double src_x, double src_y, double & dest_x, double & dest_y)
| Translates coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations.
bool | contains (double x, double y) const
| Tests if a given point is contained in the widget.
Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT)
| Finds the descendant of the widget closest to a point.
const Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT) const
| Finds the descendant of the widget closest to a point.
void | add_controller (const Glib::RefPtr< EventController > & controller)
| Adds an event controller to the widget.
void | remove_controller (const Glib::RefPtr< EventController > & controller)
| Removes an event controller from the widget.
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context that is configured for the widget.
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context that is configured for the widget.
void | set_font_options (const Cairo::FontOptions & options)
| Sets the cairo_font_options_t used for text rendering in the widget.
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options().
Cairo::FontOptions | get_font_options () const
| Returns the cairo_font_options_t of the widget.
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring & text)
| Creates a new Pango::Layout that is configured for the widget.
void | set_direction (TextDirection dir)
| Sets the reading direction on the widget.
TextDirection | get_direction () const
| Gets the reading direction for the widget.
void | set_cursor (const Glib::RefPtr< Gdk::Cursor > & cursor)
| Sets the cursor to be shown when the pointer hovers over the widget.
void | set_cursor (const Glib::ustring & name={})
| Sets a named cursor to be shown when pointer devices point towards the widget.
Glib::RefPtr< Gdk::Cursor > | get_cursor ()
| Gets the cursor set on the widget.
Glib::RefPtr< const Gdk::Cursor > | get_cursor () const
| Gets the cursor set on the widget.
std::vector< Widget * > | list_mnemonic_labels ()
| Returns the widgets for which this widget is the target of a mnemonic.
std::vector< const Widget * > | list_mnemonic_labels () const
| Returns the widgets for which this widget is the target of a mnemonic.
void | add_mnemonic_label (Widget & label)
| Adds a widget to the list of mnemonic labels for this widget.
void | remove_mnemonic_label (Widget & label)
| Removes a widget from the list of mnemonic labels for this widget.
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a drag movement has passed the GTK drag threshold.
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget.
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget.
void | set_parent (Widget & parent)
| Sets the parent widget of the widget.
void | unparent ()
| Removes widget from its parent.
void | map ()
| Causes a widget to be mapped if it isn’t already.
void | unmap ()
| Causes a widget to be unmapped if it’s currently mapped.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display of the widget.
void | set_tooltip_text (const Glib::ustring & text)
| Sets the contents of the tooltip for the widget.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for the widget.
void | set_tooltip_markup (const Glib::ustring & markup)
| Sets the contents of the tooltip for widget.
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for the widget.
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on the widget.
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property.
bool | in_destruction () const
| Returns whether the widget is currently being destroyed.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to the widget.
Glib::RefPtr< const StyleContext > | get_style_context () const
| Returns the style context associated to the widget.
guint | add_tick_callback (const SlotTick & slot)
| Queues an animation frame update and adds a callback to be called before each frame.
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback().
void | insert_action_group (const Glib::ustring & name, const Glib::RefPtr< Gio::ActionGroup > & group)
| Inserts an action group into the widget's actions.
void | remove_action_group (const Glib::ustring & name)
| Removes a group from the widget.
bool | activate_action (const Glib::ustring & name, const Glib::VariantBase & args={})
| Looks up the action in the action groups associated with the widget and its ancestors, and activates it.
void | activate_default ()
| Activates the default.activate action for the widget.
void | set_font_map (const Glib::RefPtr< Pango::FontMap > & font_map)
| Sets the font map to use for text rendering in the widget.
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map of the widget.
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map of the widget.
Widget * | get_first_child ()
| Returns the widget’s first child.
const Widget * | get_first_child () const
| Returns the widget’s first child.
Widget * | get_last_child ()
| Returns the widget’s last child.
const Widget * | get_last_child () const
| Returns the widget’s last child.
Widget * | get_next_sibling ()
| Returns the widget’s next sibling.
const Widget * | get_next_sibling () const
| Returns the widget’s next sibling.
Widget * | get_prev_sibling ()
| Returns the widget’s previous sibling.
const Widget * | get_prev_sibling () const
| Returns the widget’s previous sibling.
std::vector< Widget * > | get_children ()
| Gets a vector of the widgetʼs current children, from first child to last.
std::vector< const Widget * > | get_children () const
| Gets a vector of the widgetʼs current children, from first child to last.
Glib::RefPtr< Gio::ListModel > | observe_children ()
| Returns a list model to track the children of the widget.
Glib::RefPtr< const Gio::ListModel > | observe_children () const
| Returns a list model to track the children of the widget.
Glib::RefPtr< Gio::ListModel > | observe_controllers ()
| Returns a list model to track the event controllers of the widget.
Glib::RefPtr< const Gio::ListModel > | observe_controllers () const
| Returns a list model to track the event controllers of the widget.
void | insert_after (Widget & parent, const Widget & previous_sibling)
| Inserts the Widget into the child widget list of parent after previous_sibling.
void | insert_before (Widget & parent, const Widget & next_sibling)
| Inserts the Widget into the child widget list of parent before next_sibling.
void | insert_at_start (Widget & parent)
| Inserts the Widget at the beginning of the child widget list of parent.
void | insert_at_end (Widget & parent)
| Inserts the Widget at the end of the child widget list of parent.
void | snapshot_child (Widget & child, const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Snapshots a child of the widget.
bool | should_layout () const
| Returns whether the widget should contribute to the measuring and allocation of its parent.
Glib::ustring | get_css_name () const
| Returns the CSS name of the widget.
void | add_css_class (const Glib::ustring & css_class)
| Adds a style class to the widget.
void | remove_css_class (const Glib::ustring & css_class)
| Removes a style from the widget.
bool | has_css_class (const Glib::ustring & css_class) const
| Returns whether a style class is currently applied to the widget.
std::vector< Glib::ustring > | get_css_classes () const
| Returns the list of style classes applied to the widget.
void | set_css_classes (const std::vector< Glib::ustring > & classes)
| Replaces the current style classes of the widget with classes.
Gdk::RGBA | get_color () const
| Gets the current foreground color for the widget's CSS style.
void | set_limit_events (bool limit_events=true)
| Sets whether the widget acts like a modal dialog, with respect to event delivery.
bool | get_limit_events () const
| Gets the value of the property_limit_events() property.
Glib::SignalProxy< void()> | signal_show ()
Glib::SignalProxy< void()> | signal_hide ()
Glib::SignalProxy< void()> | signal_map ()
| Emitted on mapping of a widget to the screen.
Glib::SignalProxy< void()> | signal_unmap ()
Glib::SignalProxy< void()> | signal_realize ()
| Emitted on realization of a widget.
Glib::SignalProxy< void()> | signal_unrealize ()
Glib::SignalProxy< void(Gtk::StateFlags)> | signal_state_flags_changed ()
Glib::SignalProxy< void(TextDirection)> | signal_direction_changed ()
Glib::SignalProxy< bool(bool)> | signal_mnemonic_activate ()
Glib::SignalProxy< void()> | signal_destroy ()
| Emitted during the dispose phase.
Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip > &)> | signal_query_tooltip ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Widget * > | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly< Root * > | property_root () const
| The Gtk::Root widget of the widget tree containing this widget.
Glib::PropertyProxy< int > | property_width_request ()
| Overrides for width request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Overrides for width request of the widget.
Glib::PropertyProxy< int > | property_height_request ()
| Overrides for height request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Overrides for height request of the widget.
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy< bool > | property_can_target ()
| Whether the widget can receive pointer events.
Glib::PropertyProxy_ReadOnly< bool > | property_can_target () const
| Whether the widget can receive pointer events.
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy< bool > | property_focusable ()
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_focusable () const
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy< bool > | property_receives_default ()
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy< Glib::RefPtr< Gdk::Cursor > > | property_cursor ()
| The cursor used by widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Cursor > > | property_cursor () const
| The cursor used by widget.
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget.
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget.
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally.
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the hexpand property.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the hexpand property.
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically.
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the vexpand property.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the vexpand property.
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget.
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget.
Glib::PropertyProxy< Overflow > | property_overflow ()
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< Overflow > | property_overflow () const
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_css_name () const
| The name of this widget in the CSS tree.
Glib::PropertyProxy< std::vector< Glib::ustring > > | property_css_classes ()
| A list of css classes applied to this widget.
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_css_classes () const
| A list of css classes applied to this widget.
Glib::PropertyProxy< Glib::RefPtr< LayoutManager > > | property_layout_manager ()
| The Gtk::LayoutManager instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< LayoutManager > > | property_layout_manager () const
| The Gtk::LayoutManager instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy< bool > | property_limit_events ()
| Makes this widget act like a modal dialog, with respect to event delivery.
Glib::PropertyProxy_ReadOnly< bool > | property_limit_events () const
| Makes this widget act like a modal dialog, with respect to event delivery.
Public Member Functions inherited from Gtk::Object
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gtk::Accessible
| Accessible (Accessible && src) noexcept
Accessible & | operator= (Accessible && src) noexcept
| ~Accessible () noexcept override
GtkAccessible * | gobj ()
| Provides access to the underlying C GObject.
const GtkAccessible * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ATContext > | get_at_context ()
| Retrieves the implementation for the given accessible object.
Glib::RefPtr< const ATContext > | get_at_context () const
| Retrieves the implementation for the given accessible object.
bool | get_platform_state (PlatformState state) const
| Queries a platform state, such as focus.
void | update_platform_state (PlatformState state)
| Informs ATs that the platform state has changed.
Glib::RefPtr< Accessible > | get_accessible_parent ()
| Retrieves the accessible parent for an accessible object.
Glib::RefPtr< const Accessible > | get_accessible_parent () const
| Retrieves the accessible parent for an accessible object.
void | set_accessible_parent (const Glib::RefPtr< Accessible > & parent, const Glib::RefPtr< Accessible > & next_sibling)
| Sets the parent and sibling of an accessible object.
Glib::RefPtr< Accessible > | get_first_accessible_child ()
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< const Accessible > | get_first_accessible_child () const
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< Accessible > | get_next_accessible_sibling ()
| Retrieves the next accessible sibling of an accessible object.
Glib::RefPtr< const Accessible > | get_next_accessible_sibling () const
| Retrieves the next accessible sibling of an accessible object.
void | update_next_accessible_sibling (const Glib::RefPtr< Accessible > & new_sibling)
| Updates the next accessible sibling.
bool | get_bounds (int & x, int & y, int & width, int & height) const
| Queries the coordinates and dimensions of this accessible.
Glib::ustring | get_accessible_id () const
| Retrieves the accessible identifier for the accessible object.
Role | get_accessible_role () const
| Retrieves the accessible role of an accessible object.
void | update_state (State state, const Glib::ValueBase & value)
| Updates an accessible state.
void | update_property (Property property, const Glib::ValueBase & value)
| Updates an accessible property.
void | update_relation (Relation relation, const Glib::ValueBase & value)
| Updates an accessible relation.
void | reset_state (State state)
| Resets the accessible state to its default value.
void | reset_property (Property property)
| Resets the accessible property to its default value.
void | reset_relation (Relation relation)
| Resets the accessible relation to its default value.
void | announce (const Glib::ustring & message, AnnouncementPriority priority)
| Requests the user's screen reader to announce the given message.
Glib::PropertyProxy< Role > | property_accessible_role ()
| The accessible role of the given Gtk::Accessible implementation.
Glib::PropertyProxy_ReadOnly< Role > | property_accessible_role () const
| The accessible role of the given Gtk::Accessible implementation.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable && src) noexcept
Buildable & | operator= (Buildable && src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject.
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object.
Public Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget (ConstraintTarget && src) noexcept
ConstraintTarget & | operator= (ConstraintTarget && src) noexcept
| ~ConstraintTarget () noexcept override
GtkConstraintTarget * | gobj ()
| Provides access to the underlying C GObject.
const GtkConstraintTarget * | gobj () const
| Provides access to the underlying C GObject.
Public Member Functions inherited from Gtk::CellLayout
| CellLayout (CellLayout && src) noexcept
CellLayout & | operator= (CellLayout && src) noexcept
| ~CellLayout () noexcept override
GtkCellLayout * | gobj ()
| Provides access to the underlying C GObject.
const GtkCellLayout * | gobj () const
| Provides access to the underlying C GObject.
template<class ColumnType>
void | pack_start (const TreeModelColumn< ColumnType > & model_column, bool expand=true)
void | pack_start (CellRenderer & cell, bool expand=true)
| Packs the cell into the beginning of cell_layout.
void | pack_end (CellRenderer & cell, bool expand=true)
| Adds the cell to the end of cell_layout.
std::vector< CellRenderer * > | get_cells ()
| Returns the cell renderers which have been added to cell_layout.
std::vector< const CellRenderer * > | get_cells () const
| Returns the cell renderers which have been added to cell_layout.
CellRenderer * | get_first_cell ()
| Gets the CellRenderer for the first column if any has been added, or nullptr otherwise.
const CellRenderer * | get_first_cell () const
| Gets the CellRenderer for the first column if any has been added, or nullptr otherwise.
void | clear ()
| Unsets all the mappings on all renderers on cell_layout and removes all renderers from cell_layout.
void | add_attribute (CellRenderer & cell, const Glib::ustring & attribute, int column)
| Adds an attribute mapping to the list in cell_layout.
void | add_attribute (const Glib::PropertyProxy_Base & property, const TreeModelColumnBase & column)
void | add_attribute (CellRenderer & cell, const Glib::ustring & attribute, const TreeModelColumnBase & column)
void | set_cell_data_func (CellRenderer & cell, const SlotCellData & slot)
void | clear_attributes (CellRenderer & cell)
| Clears all existing attributes previously set with set_attributes().
void | reorder (CellRenderer & cell, int position)
| Re-inserts cell at position.
Glib::RefPtr< CellArea > | get_area ()
| Returns the underlying Gtk::CellArea which might be cell_layout if called on a Gtk::CellArea or might be nullptr if no Gtk::CellArea is used by cell_layout.
Glib::RefPtr< const CellArea > | get_area () const
| Returns the underlying Gtk::CellArea which might be cell_layout if called on a Gtk::CellArea or might be nullptr if no Gtk::CellArea is used by cell_layout.
template<class T_ModelColumnType>
void | pack_start (const TreeModelColumn< T_ModelColumnType > & column, bool expand)
Public Member Functions inherited from Gtk::CellEditable
| CellEditable (CellEditable && src) noexcept
CellEditable & | operator= (CellEditable && src) noexcept
| ~CellEditable () noexcept override
GtkCellEditable * | gobj ()
| Provides access to the underlying C GObject.
const GtkCellEditable * | gobj () const
| Provides access to the underlying C GObject.
void | start_editing (const Glib::RefPtr< const Gdk::Event > & event)
| Begins editing on a cell_editable.
void | editing_done ()
| Emits the GtkCellEditable::editing-done signal.
void | remove_widget ()
| Emits the GtkCellEditable::remove-widget signal.
Glib::SignalProxy< void()> | signal_editing_done ()
Glib::SignalProxy< void()> | signal_remove_widget ()
Glib::PropertyProxy< bool > | property_editing_canceled ()
| Indicates whether editing on the cell has been canceled.
Glib::PropertyProxy_ReadOnly< bool > | property_editing_canceled () const
| Indicates whether editing on the cell has been canceled.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets.
static TextDirection | get_default_direction ()
| Obtains the default reading direction.
Static Public Member Functions inherited from Gtk::Accessible
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::ConstraintTarget
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::CellLayout
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::CellEditable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
virtual void | on_changed ()
| This is a default handler for the signal signal_changed().
virtual Glib::ustring | on_format_entry_text (const TreeModel::Path & path)
| This is a default handler for the signal signal_format_entry_text().
Protected Member Functions inherited from Gtk::Widget
virtual void | root_vfunc ()
virtual void | unroot_vfunc ()
virtual void | size_allocate_vfunc (int width, int height, int baseline)
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | measure_vfunc (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
virtual bool | grab_focus_vfunc ()
virtual void | set_focus_child_vfunc (Widget * child)
| Sets the focused child of widget.
virtual void | compute_expand_vfunc (bool & hexpand_p, bool & vexpand_p)
virtual bool | contains_vfunc (double x, double y) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Widget ()
void | realize ()
| Creates the GDK resources associated with a widget.
void | unrealize ()
| Causes a widget to be unrealized.
void | realize_if_needed ()
void | set_focus_child (Widget & child)
| Set the focus child of the widget.
void | unset_focus_child ()
| Unsets the focus child of the widget.
Widget * | get_focus_child ()
| Returns the focus child of the widget.
const Widget * | get_focus_child () const
| Returns the focus child of the widget.
virtual void | on_show ()
| This is a default handler for the signal signal_show().
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_map ()
| This is a default handler for the signal signal_map().
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap().
virtual void | on_realize ()
| This is a default handler for the signal signal_realize().
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize().
virtual void | on_state_flags_changed (Gtk::StateFlags previous_state_flags)
| This is a default handler for the signal signal_state_flags_changed().
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed().
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate().
virtual bool | on_query_tooltip (int x, int y, bool keyboard_tooltip, const Glib::RefPtr< Tooltip > & tooltip)
| This is a default handler for the signal signal_query_tooltip().
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Accessible
| Accessible ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::CellLayout
| CellLayout ()
| You should derive from this class to use it.
virtual void | pack_start_vfunc (CellRenderer * cell, bool expand)
virtual void | pack_end_vfunc (CellRenderer * cell, bool expand)
virtual void | clear_vfunc ()
virtual void | add_attribute_vfunc (CellRenderer * cell, const Glib::ustring & attribute, int column)
virtual void | clear_attributes_vfunc (CellRenderer * cell)
virtual void | reorder_vfunc (CellRenderer * cell, int position)
Protected Member Functions inherited from Gtk::CellEditable
| CellEditable ()
| You should derive from this class to use it.
virtual void | start_editing_vfunc (const Glib::RefPtr< const Gdk::Event > & event)
virtual void | on_editing_done ()
| This is a default handler for the signal signal_editing_done().
virtual void | on_remove_widget ()
| This is a default handler for the signal signal_remove_widget().

## Related Symbols
(Note that these are not member symbols.)
Gtk::ComboBox * | wrap (GtkComboBox * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Widget
Gtk::Widget * | wrap (GtkWidget * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Accessible
Glib::RefPtr< Gtk::Accessible > | wrap (GtkAccessible * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::ConstraintTarget
Glib::RefPtr< Gtk::ConstraintTarget > | wrap (GtkConstraintTarget * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::CellLayout
Glib::RefPtr< Gtk::CellLayout > | wrap (GtkCellLayout * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::CellEditable
Glib::RefPtr< Gtk::CellEditable > | wrap (GtkCellEditable * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A widget used to choose from a list of items.

A ComboBox is a widget that allows the user to choose from a list of valid choices. The ComboBox displays the selected choice. When activated, the ComboBox displays a popup which allows the user to make a new choice. The style in which the selected value is displayed, and the style of the popup is determined by the current theme. It may be similar to a Windows-style combo box.

The ComboBox uses the model-view pattern; the list of valid choices is specified in the form of a tree model, and the display of the choices can be adapted to the data in the model by using cell renderers, as you would in a tree view. This is possible since ComboBox implements the CellLayout interface. The tree model holding the valid choices is not restricted to a flat list, it can be a real tree, and the popup will reflect the tree structure.

To allow the user to enter values not in the model, the 'has-entry' property allows the ComboBox to contain a Gtk::Entry. This entry can be accessed by calling get_entry(), or you can just call get_entry_text() to get the text from the Entry.

For a simple list of textual choices, the model-view API of ComboBox can be a bit overwhelming. In this case, ComboBoxText offers a simple alternative. Both ComboBox and ComboBoxText can contain an entry.

Deprecated
  4.10: Use Gtk::DropDown instead.

The ComboBox widget looks like this:

## Member Typedef Documentation

## ◆ SlotRowSeparator

typedef TreeView::SlotRowSeparator Gtk::ComboBox::SlotRowSeparator

## Constructor & Destructor Documentation

## ◆ ComboBox() [1/4]

Gtk::ComboBox::ComboBox | ( | ComboBox && | src | ) |
| noexcept

## ◆ ComboBox() [2/4]

Gtk::ComboBox::ComboBox | ( | const ComboBox & |  | ) |
| delete

## ◆ ~ComboBox()

Gtk::ComboBox::~ComboBox | ( |  | ) |
| overridenoexcept

## ◆ ComboBox() [3/4]

Gtk::ComboBox::ComboBox | ( | bool | has_entry = false | ) |
| explicit

Creates a new empty ComboBox, optionally with an entry.

Parameters

  has_entry | If this is true then this will have an Entry widget.

## ◆ ComboBox() [4/4]

Gtk::ComboBox::ComboBox | ( | const Glib::RefPtr< TreeModel > & | model,
|  | bool | has_entry = false )
| explicit

Creates a new ComboBox with the model initialized to model, optionally with an entry.

Parameters

  model | The model containing data to display in the ComboBox.
  has_entry | If this is true then this will have an Entry widget.

## Member Function Documentation

## ◆ get_active() [1/2]

TreeModel::iterator Gtk::ComboBox::get_active | ( |  | ) |

Gets an iterator that points to the current active item, if it exists.

Returns
  The iterator.

## ◆ get_active() [2/2]

TreeModel::const_iterator Gtk::ComboBox::get_active | ( |  | ) | const

Gets an iterator that points to the current active item, if it exists.

Returns
  The iterator.

## ◆ get_active_id()

Glib::ustring Gtk::ComboBox::get_active_id | ( |  | ) | const

Returns the ID of the active row of combo_box.

This value is taken from the active row and the column specified by the property_id_column() property of combo_box (see set_id_column()).

The returned value is an interned string which means that you can compare the pointer by value to other interned strings and that you must not free it.

If the property_id_column() property of combo_box is not set, or if no row is active, or if the active row has a nullptr ID value, then nullptr is returned.

Deprecated: 4.10: Use Gtk::DropDown

Returns
  The ID of the active row.

## ◆ get_active_row_number()

int Gtk::ComboBox::get_active_row_number | ( |  | ) | const

Returns the index of the currently active item.

If the model is a non-flat treemodel, and the active item is not an immediate child of the root of the tree, this function returns gtk_tree_path_get_indices (path)[0], where path is the Gtk::TreePath of the active item.

Deprecated: 4.10: Use Gtk::DropDown

Returns
  An integer which is the index of the currently active item, or -1 if there’s no active item.

## ◆ get_button_sensitivity()

SensitivityType Gtk::ComboBox::get_button_sensitivity | ( |  | ) | const

Returns whether the combo box sets the dropdown button sensitive or not when there are no items in the model.

Deprecated: 4.10: Use Gtk::DropDown

Returns
  Gtk::SensitivityType::ON if the dropdown button is sensitive when the model is empty, Gtk::SensitivityType::OFF if the button is always insensitive or Gtk::SensitivityType::AUTO if it is only sensitive as long as the model has one item to be selected.

## ◆ get_child() [1/2]

Widget * Gtk::ComboBox::get_child | ( |  | ) |

Gets the child widget of combo_box.

Deprecated: 4.10: Use Gtk::DropDown

Returns
  The child widget of combo_box.

## ◆ get_child() [2/2]

const Widget * Gtk::ComboBox::get_child | ( |  | ) | const

Gets the child widget of combo_box.

Deprecated: 4.10: Use Gtk::DropDown

Returns
  The child widget of combo_box.

## ◆ get_entry() [1/2]

Entry * Gtk::ComboBox::get_entry | ( |  | ) |

See also
  get_child().

## ◆ get_entry() [2/2]

const Entry * Gtk::ComboBox::get_entry | ( |  | ) | const

See also
  get_child().

## ◆ get_entry_text()

Glib::ustring Gtk::ComboBox::get_entry_text | ( |  | ) | const

Get the text in the entry, if there is an entry.

## ◆ get_entry_text_column()

int Gtk::ComboBox::get_entry_text_column | ( |  | ) | const

Returns the column which combo_box is using to get the strings from to display in the internal entry.

Deprecated: 4.10: Use Gtk::DropDown

Returns
  A column in the data source model of combo_box.

## ◆ get_has_entry()

bool Gtk::ComboBox::get_has_entry | ( |  | ) | const

Returns whether the combo box has an entry.

Deprecated: 4.10: Use Gtk::DropDown

Returns
  Whether there is an entry in combo_box.

## ◆ get_id_column()

int Gtk::ComboBox::get_id_column | ( |  | ) | const

Returns the column which combo_box is using to get string IDs for values from.

Deprecated: 4.10: Use Gtk::DropDown

Returns
  A column in the data source model of combo_box.

## ◆ get_model() [1/2]

Glib::RefPtr< TreeModel > Gtk::ComboBox::get_model | ( |  | ) |

Returns the Gtk::TreeModel of combo_box.

Deprecated: 4.10: Use Gtk::DropDown

Returns
  A Gtk::TreeModel which was passed during construction.

## ◆ get_model() [2/2]

Glib::RefPtr< const TreeModel > Gtk::ComboBox::get_model | ( |  | ) | const

Returns the Gtk::TreeModel of combo_box.

Deprecated: 4.10: Use Gtk::DropDown

Returns
  A Gtk::TreeModel which was passed during construction.

## ◆ get_popup_fixed_width()

bool Gtk::ComboBox::get_popup_fixed_width | ( |  | ) | const

Gets whether the popup uses a fixed width.

Deprecated: 4.10: Use Gtk::DropDown

Returns
  true if the popup uses a fixed width.

## ◆ get_type()

GType Gtk::ComboBox::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkComboBox * Gtk::ComboBox::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkComboBox * Gtk::ComboBox::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ on_changed()

virtual void Gtk::ComboBox::on_changed | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_changed().

## ◆ on_format_entry_text()

virtual Glib::ustring Gtk::ComboBox::on_format_entry_text | ( | const TreeModel::Path & | path | ) |
| protectedvirtual

This is a default handler for the signal signal_format_entry_text().

## ◆ operator=() [1/2]

ComboBox & Gtk::ComboBox::operator= | ( | ComboBox && | src | ) |
| noexcept

## ◆ operator=() [2/2]

ComboBox & Gtk::ComboBox::operator= | ( | const ComboBox & |  | ) |
| delete

## ◆ popdown()

void Gtk::ComboBox::popdown | ( |  | ) |

Hides the menu or dropdown list of combo_box.

This function is mostly intended for use by accessibility technologies; applications should have little use for it.

Deprecated: 4.10: Use Gtk::DropDown

## ◆ popup() [1/2]

void Gtk::ComboBox::popup | ( |  | ) |

Pops up the menu or dropdown list of combo_box.

This function is mostly intended for use by accessibility technologies; applications should have little use for it.

Before calling this, combo_box must be mapped, or nothing will happen.

Deprecated: 4.10: Use Gtk::DropDown

## ◆ popup() [2/2]

void Gtk::ComboBox::popup | ( | const Glib::RefPtr< Gdk::Device > & | device | ) |

Pops up the menu of combo_box.

Note that currently this does not do anything with the device, as it was previously only used for list-mode combo boxes, and those were removed in GTK 4. However, it is retained in case similar functionality is added back later.

Deprecated: 4.10: Use Gtk::DropDown

Parameters

  device | A Gdk::Device.

## ◆ property_active() [1/2]

Glib::PropertyProxy< int > Gtk::ComboBox::property_active | ( |  | ) |

The item which is currently active.

If the model is a non-flat treemodel, and the active item is not an immediate child of the root of the tree, this property has the value gtk_tree_path_get_indices (path)[0], where path is the Gtk::TreePath of the active item.

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_active() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::ComboBox::property_active | ( |  | ) | const

The item which is currently active.

If the model is a non-flat treemodel, and the active item is not an immediate child of the root of the tree, this property has the value gtk_tree_path_get_indices (path)[0], where path is the Gtk::TreePath of the active item.

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_active_id() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::ComboBox::property_active_id | ( |  | ) |

The value of the ID column of the active row.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_active_id() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::ComboBox::property_active_id | ( |  | ) | const

The value of the ID column of the active row.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_button_sensitivity() [1/2]

Glib::PropertyProxy< SensitivityType > Gtk::ComboBox::property_button_sensitivity | ( |  | ) |

Whether the dropdown button is sensitive when the model is empty.

Default value: Gtk::SensitivityType::AUTO

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_button_sensitivity() [2/2]

Glib::PropertyProxy_ReadOnly< SensitivityType > Gtk::ComboBox::property_button_sensitivity | ( |  | ) | const

Whether the dropdown button is sensitive when the model is empty.

Default value: Gtk::SensitivityType::AUTO

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_child() [1/2]

Glib::PropertyProxy< Widget * > Gtk::ComboBox::property_child | ( |  | ) |

The child widget.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_child() [2/2]

Glib::PropertyProxy_ReadOnly< Widget * > Gtk::ComboBox::property_child | ( |  | ) | const

The child widget.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_entry_text_column() [1/2]

Glib::PropertyProxy< int > Gtk::ComboBox::property_entry_text_column | ( |  | ) |

The model column to associate with strings from the entry.

This is property only relevant if the combo was created with property_has_entry() is true.

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_entry_text_column() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::ComboBox::property_entry_text_column | ( |  | ) | const

The model column to associate with strings from the entry.

This is property only relevant if the combo was created with property_has_entry() is true.

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_has_entry()

Glib::PropertyProxy_ReadOnly< bool > Gtk::ComboBox::property_has_entry | ( |  | ) | const

Whether the combo box has an entry.

Default value: false

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_has_frame() [1/2]

Glib::PropertyProxy< bool > Gtk::ComboBox::property_has_frame | ( |  | ) |

The has-frame property controls whether a frame is drawn around the entry.

Default value: true

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_has_frame() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ComboBox::property_has_frame | ( |  | ) | const

The has-frame property controls whether a frame is drawn around the entry.

Default value: true

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_id_column() [1/2]

Glib::PropertyProxy< int > Gtk::ComboBox::property_id_column | ( |  | ) |

The model column that provides string IDs for the values in the model, if != -1.

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_id_column() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::ComboBox::property_id_column | ( |  | ) | const

The model column that provides string IDs for the values in the model, if != -1.

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [1/2]

Glib::PropertyProxy< Glib::RefPtr< TreeModel > > Gtk::ComboBox::property_model | ( |  | ) |

The model from which the combo box takes its values.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TreeModel > > Gtk::ComboBox::property_model | ( |  | ) | const

The model from which the combo box takes its values.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_popup_fixed_width() [1/2]

Glib::PropertyProxy< bool > Gtk::ComboBox::property_popup_fixed_width | ( |  | ) |

Whether the popup's width should be a fixed width matching the allocated width of the combo box.

Default value: true

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_popup_fixed_width() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ComboBox::property_popup_fixed_width | ( |  | ) | const

Whether the popup's width should be a fixed width matching the allocated width of the combo box.

Default value: true

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_popup_shown()

Glib::PropertyProxy_ReadOnly< bool > Gtk::ComboBox::property_popup_shown | ( |  | ) | const

Whether the combo boxes dropdown is popped up.

Note that this property is mainly useful, because it allows you to connect to notify::popup-shown.

Default value: false

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_active() [1/2]

void Gtk::ComboBox::set_active | ( | const TreeModel::const_iterator & | iter | ) |

Sets the current active item to be the one referenced by iter.

If iter is nullptr, the active item is unset.

Deprecated: 4.10: Use Gtk::DropDown

Parameters

  iter | The Gtk::TreeIter.

## ◆ set_active() [2/2]

void Gtk::ComboBox::set_active | ( | int | index | ) |

Sets the active item of combo_box to be the item at index.

Deprecated: 4.10: Use Gtk::DropDown

Parameters

  index | An index in the model passed during construction, or -1 to have no active item.

## ◆ set_active_id()

bool Gtk::ComboBox::set_active_id | ( | const Glib::ustring & | active_id | ) |

Changes the active row of the combo box to the one that has an ID equal to active_id.

If property_id_column() is unset or if no row has the given ID then the function does nothing and returns false.

Parameters

  active_id | The ID of the row that should be set to active.

Returns
  true if a row with a matching ID was found.

Since gtkmm 3.6

## ◆ set_button_sensitivity()

void Gtk::ComboBox::set_button_sensitivity | ( | SensitivityType | sensitivity | ) |

Sets whether the dropdown button of the combo box should update its sensitivity depending on the model contents.

Deprecated: 4.10: Use Gtk::DropDown

Parameters

  sensitivity | Specify the sensitivity of the dropdown button.

## ◆ set_child()

void Gtk::ComboBox::set_child | ( | Widget & | child | ) |

Sets the child widget of combo_box.

Deprecated: 4.10: Use Gtk::DropDown

Parameters

  child | The child widget.

## ◆ set_entry_text_column() [1/2]

void Gtk::ComboBox::set_entry_text_column | ( | const TreeModelColumnBase & | text_column | ) | const

Sets the model column which combo_box should use to get strings from to be text_column.

For this column no separate Gtk::CellRenderer is needed.

The column text_column in the model of combo_box must be of type G_TYPE_STRING.

This is only relevant if combo_box has been created with property_has_entry() as true.

Deprecated: 4.10: Use Gtk::DropDown

Parameters

  text_column | A column in model to get the strings from for the internal entry.

## ◆ set_entry_text_column() [2/2]

void Gtk::ComboBox::set_entry_text_column | ( | int | text_column | ) |

Sets the model column which combo_box should use to get strings from to be text_column.

For this column no separate Gtk::CellRenderer is needed.

The column text_column in the model of combo_box must be of type G_TYPE_STRING.

This is only relevant if combo_box has been created with property_has_entry() as true.

Deprecated: 4.10: Use Gtk::DropDown

Parameters

  text_column | A column in model to get the strings from for the internal entry.

## ◆ set_id_column()

void Gtk::ComboBox::set_id_column | ( | int | id_column | ) |

Sets the model column which combo_box should use to get string IDs for values from.

The column id_column in the model of combo_box must be of type G_TYPE_STRING.

Deprecated: 4.10: Use Gtk::DropDown

Parameters

  id_column | A column in model to get string IDs for values from.

## ◆ set_model()

void Gtk::ComboBox::set_model | ( | const Glib::RefPtr< TreeModel > & | model | ) |

Sets the model used by combo_box to be model.

Will unset a previously set model (if applicable). Use unset_model() to unset the old model.

Note that this function does not clear the cell renderers. You have to call Gtk::CellLayout::clear() yourself if you need to set up different cell renderers for the new model.

Deprecated: 4.10: Use Gtk::DropDown

Parameters

  model | A Gtk::TreeModel.

## ◆ set_popup_fixed_width()

void Gtk::ComboBox::set_popup_fixed_width | ( | bool | fixed = true | ) |

Specifies whether the popup’s width should be a fixed width.

If fixed is true, the popup's width is set to match the allocated width of the combo box.

Deprecated: 4.10: Use Gtk::DropDown

Parameters

  fixed | Whether to use a fixed popup width.

## ◆ set_row_separator_func()

void Gtk::ComboBox::set_row_separator_func | ( | const SlotRowSeparator & | slot | ) |

Sets the row separator function, which is used to determine whether a row should be drawn as a separator.

See also unset_row_separator_func().

Parameters

  Slots | The callback.

## ◆ signal_changed()

Glib::SignalProxy< void()> Gtk::ComboBox::signal_changed | ( |  | ) |

Slot Prototype:
  void on_my_changed()

Flags: Run Last

Emitted when the active item is changed.

The can be due to the user selecting a different item from the list, or due to a call to Gtk::ComboBox::set_active_iter(). It will also be emitted while typing into the entry of a combo box with an entry.

## ◆ signal_format_entry_text()

Glib::SignalProxy< Glib::ustring(const TreeModel::Path &)> Gtk::ComboBox::signal_format_entry_text | ( |  | ) |

Slot Prototype:
  Glib::ustring on_my_format_entry_text(const TreeModel::Path& path)

Flags: Run Last

Emitted to allow changing how the text in a combo box's entry is displayed.

See property_has_entry().

Connect a signal handler which returns an allocated string representing path. That string will then be used to set the text in the combo box's entry. The default signal handler uses the text from the property_entry_text_column() model column.

Here's an example signal handler which fetches data from the model and displays it in the entry.

[C example ellipted]

Parameters

  path | The Gtk::TreePath string from the combo box's current model to format text for.

Returns
  A newly allocated string representing path for the current Gtk::ComboBox model.

## ◆ unset_active()

void Gtk::ComboBox::unset_active | ( |  | ) |

Causes no item to be active.

See also set_active().

## ◆ unset_child()

void Gtk::ComboBox::unset_child | ( |  | ) |

## ◆ unset_model()

void Gtk::ComboBox::unset_model | ( |  | ) |

Remove the model from the ComboBox.

See also
  set_model().

## ◆ unset_row_separator_func()

void Gtk::ComboBox::unset_row_separator_func | ( |  | ) |

Causes no separators to be drawn.

## Friends And Related Symbol Documentation

## ◆ wrap()

Gtk::ComboBox * wrap | ( | GtkComboBox * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.